################
# Ex0 solution #
################
## Copy and paste in R:
#-----------------------------------------------------------------------
# Load household data:
data(data.examples)

# Creation of the object to be calibrated:
des<-e.svydesign(data=example,ids=~towcod+famcod,strata=~SUPERSTRATUM,
     weights=~weight)

# 3) Calibration (global solution) on the joint distribution of sex
#    and marstat (totals in pop03):
descal03<-e.calibrate(design=des,df.population=pop03,
          calmodel=~marstat:sex-1,calfun="logit",bounds=bounds)
#-----------------------------------------------------------------------


# Estimate total income, its CV% and its DEff:

#  A) at the nation level (i.e. for the whole population)
#     A1) HT
svystatTM(des, ~income, vartype="cvpct", deff=TRUE)
#     A2) CAL
svystatTM(descal03, ~income, vartype="cvpct", deff=TRUE)

#  B) inside domains defined by crossing sex and marstat
#     B1) HT
svystatTM(des, ~income, ~sex:marstat, vartype="cvpct", deff=TRUE)
#     B2) CAL
svystatTM(descal03, ~income, ~sex:marstat, vartype="cvpct", deff=TRUE)


## Answer: CAL estimates exhibit smaller estimated variability than HT, both at
##         nation level and at domain level.
##
##         This should come as NO SURPRISE, since calibration in general
##         decreases sampling variance, as compared to HT.
##         MOREOVER, if one inspects the used calibration totals...
pop03

##         ...one realizes that calibration REMOVES ANY VARIABILITY from the
##         estimates of the SIZES of both the population and the domains:
svystatTM(des, ~I(sex:marstat), vartype="cvpct")
svystatTM(descal03, ~I(sex:marstat), vartype="cvpct")

##         RECALL that the sampling variability of the SIZE of the estimation
##         domains contributes to the sampling variability of domain ESTIMATES
##         of interest variables.
