################
# Ex1 solution #
################
# Load ReGenesees
library(ReGenesees)

# Load Design_Ex1_2.RData. May use the GUI of ReGenesees or the command line (change the
# path to the file if needed).
load("Design_Ex1_2.RData")

# Print on screen all the survey design objects:
des1
des2
des3
des4
des5

## A1: Only des 4 is calibrated.
# Indeed:
data.class(des4)

## A2: No design is unstratified.

## A3: Only des5 strata have been collapsed.

## A4: There are 2 pairs of designs which are linked:
# PAIR 1: des2 and des4
#         des4 has been obtained calibrating des2
# Indeed, they share the same data origin:
attr(des2, "data")
attr(des4, "data")

# PAIR 2: des1 and des5
#         des5 has been obtained collapsing the strata of des1 
# Indeed, they share the same data origin:
attr(des1, "data")
attr(des5, "data")


# Sum the weights of des3:
N3 <- sum(weights(des3))
N3

## A5: N3 is the HT estimate of the size of the target population, in terms of
##     elementary units.


# Ratio between the weights of des4 and des2:
g <- weights(des4)/weights(des2)

# Range of g
range(g)

## A6: Since des4 has been obtained calibrating des2 (see A4 above),
##     the vector g is the ratio between calibrated weights and initial weights,
##     namely the calibration adjustment vector (also named g-weights).
# Indeed, invoking ReGenesees function g.range on des4 yields exactly the same
# result:
g.range(des4)



################
# Ex2 solution #
################
## A7: The only object whose survey data have the same number of rows of 'new',
##     as well as some variables in common with it is des3.
# Indeed:
nrow(des3$variables)
nrow(new)
# and:
names(des3$variables)
names(new)

# Of the common variables 'key' and 'ssu' only 'key' can actually be used to
# join des3 data with new.
# Indeed, variable 'ssu' is not a good key...
des.merge(design = des3, data = new, key = ~ssu)

# ...whereas 'key' works fine:
newdes <- des.merge(design = des3, data = new, key = ~key)

# The data stored inside newdes are:
newdes$variables
