################
# Ex1 solution #
################
# Load R_Ex1_2.RData. May use the GUI of ReGenesees or the command line (change the
# path to the file if needed).
load("R_Ex1_2.RData")

# 1)
class(small$stratum)
# A character, not a factor. Thus, must convert it to factor
small$stratum <- factor(small$stratum)
# Check
class(small$stratum)
small$stratum


# 2)
small <- with(small, small[order(stratum, towcod, famcod, age6c, sex), ])
# Have a look...
small
# ...Much more readable now!
# REMARK: if your solution was right, you should find that variable 'k' is now
#         sorted in increasing order


# 3)
# Compute the sample mean and median of income
mean.income <- mean(small$income)
mean.income

med.income <- median(small$income)
## or, eqivalently, med.income <- quantile(small$income, probs=0.5)
med.income


# 4)
# Build poverty status factor, based on a relative poverty threshold given by
# 0.6*med.income
small$poverty <- factor(ifelse(small$income < 0.6*med.income, "YES", "NO"))
small


################
# Ex2 solution #
################
# Keep using dataframe 'small' from previous exercise

# 1) Sample counts and proportions of poor and non-poor individuals
## Poor/Non-poor counts
table(small$poverty)
## Poor/Non-poor proportions
table(small$poverty)/nrow(small)

# Poverty rate
pov.rate <- table(small$poverty)["YES"]/nrow(small)
pov.rate


# 2) Compute the sample mena of by poverty status
mean.income.pov <- tapply(small$income, small$poverty, FUN = mean)
mean.income.pov


# 3)
#### FIRST solution ####
# 3.1)
small$ntow <- with(small, ave(towcod, stratum, FUN = count.distinct))
small

# 3.2)
small$nfam <- with(small, ave(famcod, towcod, FUN = count.distinct))
small

# 3.3)
small$ftow <- small$ntow/small$Ntow
small

# 3.4)
small$ffam <- small$nfam/small$Nfam
small


# #### SECOND solution (discuss it) ####
# # 3.1)
# ntow <- tapply(small$tow, small$stratum, FUN = count.distinct)
# small$ntow <- as.numeric(ntow)[small$stratum]
# small

# # 3.2)
# nfam <- tapply(small$fam,small$tow, FUN = count.distinct)
# small$nfam <- as.numeric(nfam)[factor(small$tow)]
# small

# # 3.3)
# small$ftow <- small$ntow/small$Ntow
# small

# # 3.4)
# small$ffam <- small$nfam/small$Nfam
# small


# #### THIRD solution (discuss it) ####
# small <- within(small, { ntow <- ave(towcod, stratum, FUN = count.distinct);
                         # nfam <- ave(famcod, towcod, FUN = count.distinct);
                         # ftow <- ntow/Ntow;
                         # ffam <- nfam/Nfam
                        # }
                # )
# small


# 4)
# Inclusion probabilities of households (and, therefore, of individuals) must
# be equal to the product of the sampling fractions of town and households.
# Design weights are reciprocal of inclusion probabilities, therefore the check
# writes:
all.equal(small$d, 1/(small$ftow*small$ffam))


# 5) Save generated/modified objects
save(small, mean.income, mean.income.pov, med.income, pov.rate, file="R_Sol1_2.RData")

